#/bin/sh
#
# LI18NUX2K.L1/hdr/langinfo_h/langinfo_h.sh
#
# Copyright (c) 1991, 1992, 1997, 1998, 1999, 2001 X/Open Company Ltd.
# (X/Open)
# trading as The Open Group
# Copyright (c) 2001, 2003 International Business Machines Corp.
# All rights reserved except as granted by this License.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the "Artistic License" which comes with this
# Kit, with the following modification:
# a) "executable(s)" should be interpreted to include
# "test case(s)"
# b) if you wish to make changes as defined in clause 2 and 3, and
# distribute a modified version of this package, then
# clauses 3c and 4c are required
# c) Clause 7 is rephrased as follows: "Subroutines supplied by you
# and linked into this Package shall not be considered part of this
# Package".
#
#
# X/OPEN, TRADING AS THE OPEN GROUP, AND IBM CORP. DISCLAIM ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL X/OPEN OR IBM CORP. BE
# LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# You should have received a copy of the Artistic License with this
# Kit, in the file named "Artistic".  If not, we'll be glad to provide one.


tet_startup="startup"			# startup function
tet_cleanup="cleanup"			# cleanup function
iclist="ic1"
ic1="tp1 tp2"

# Check macros.
tp1()
{
	tpstart "Test for langinfo.h."
	tet_infoline "Check the following macros are defined:"
	tet_infoline " CODESET"
        tet_infoline " D_T_FMT D_FMT T_FMT T_FMT_AMPM AM_STR PM_STR"
	tet_infoline " DAY_1 DAY_2 DAY_3 DAY_4 DAY_5 DAY_6 DAY_7"
	tet_infoline " ABDAY_1 ABDAY_2 ABDAY_3 ABDAY_4 ABDAY_5 ABDAY_6 ABDAY_7"
	tet_infoline " MON_1 MON_2 MON_3 MON_4 MON_5 MON_6"
	tet_infoline " MON_7 MON_8 MON_9 MON_10 MON_11 MON_12"
        tet_infoline " ABMON_1 ABMON_2 ABMON_3 ABMON_4 ABMON_5 ABMON_6"
	tet_infoline " ABMON_7 ABMON_8 ABMON_9 ABMON_10 ABMON_11 ABMON_12"
	tet_infoline " ERA ERA_D_FMT ERA_D_T_FMT ERA_T_FMT ALT_DIGITS"
	tet_infoline " RADIXCHAR THOUSEP"
	tet_infoline " YESEXPR NOEXPR YESSTR NOSTR"
	tet_infoline " CRNCYSTR"

	tet_infoline "* NOTICE *"
	tet_infoline "The following macro is defined before header is included."
	tet_infoline " #define _XOPEN_SOURCE 500"

	export define_macro="_XOPEN_SOURCE 500"
	check_macros CODESET \
	             D_T_FMT D_FMT T_FMT T_FMT_AMPM AM_STR PM_STR \
		     DAY_1 DAY_2 DAY_3 DAY_4 DAY_5 DAY_6 DAY_7 \
		     ABDAY_1 ABDAY_2 ABDAY_3 ABDAY_4 ABDAY_5 ABDAY_6 ABDAY_7 \
		     MON_1 MON_2 MON_3 MON_4 MON_5 MON_6 \
		     MON_7 MON_8 MON_9 MON_10 MON_11 MON_12 \
		     ABMON_1 ABMON_2 ABMON_3 ABMON_4 ABMON_5 ABMON_6 \
		     ABMON_7 ABMON_8 ABMON_9 ABMON_10 ABMON_11 ABMON_12 \
		     ERA ERA_D_FMT ERA_D_T_FMT ERA_T_FMT ALT_DIGITS \
		     RADIXCHAR THOUSEP \
		     YESEXPR NOEXPR YESSTR NOSTR \
		     CRNCYSTR 
	unset define_macro

	if test ${?} = 0 ; then
	  tet_infoline "All macros are defined."
	  tet_result PASS
	else
	  tet_infoline "Some macros are not defined."
	  tet_result FAIL
	fi
}

# Check functions.
tp2()
{
	tpstart "Test for langinfo.h."
	tet_infoline "Check the following functions is defined:"
	tet_infoline " nl_langinfo"

	check_functions nl_langinfo

	if test ${?} = 0 ; then
	  tet_infoline "All functions are defined."
	  tet_result PASS
	else
	  tet_infoline "Some function are not defined."
	  tet_result FAIL
	fi
}

startup() # startup function
{
	rm -f out.stdout out.stderr > /dev/null 2>&1

	export header_name="langinfo.h"
	rm -f *.c *.o *.out >/dev/null 2>&1
}


cleanup() # clean-up function
{
	rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/i18nfuncs.sh
. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
