#/bin/sh
#
# LI18NUX2K.L1/utils/nm/nm.sh
#
# Copyright (c) 1991, 1992, 1997, 1998, 1999, 2001 X/Open Company Ltd.
# (X/Open)
# trading as The Open Group
# Copyright (c) 2001, 2003 International Business Machines Corp.
# All rights reserved except as granted by this License.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the "Artistic License" which comes with this
# Kit, with the following modification:
# a) "executable(s)" should be interpreted to include
# "test case(s)"
# b) if you wish to make changes as defined in clause 2 and 3, and
# distribute a modified version of this package, then
# clauses 3c and 4c are required
# c) Clause 7 is rephrased as follows: "Subroutines supplied by you
# and linked into this Package shall not be considered part of this
# Package".
#
#
# X/OPEN, TRADING AS THE OPEN GROUP, AND IBM CORP. DISCLAIM ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL X/OPEN OR IBM CORP. BE
# LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# You should have received a copy of the Artistic License with this
# Kit, in the file named "Artistic".  If not, we'll be glad to provide one.


tet_startup="startup"			# startup function
tet_cleanup="cleanup"			# cleanup function
iclist="ic1"
ic1="tp1"

targetlocale="LTP_1.UTF-8"

tp1()
{
	tet_infoline "* When -v option is not specified, verify this utility sorts output according to the collating sequence of the current locale."
	tet_infoline " "

cat > nm_test.c <<EOF
void Afunc (void) {}
void Bfunc (void) {}
void Czfunc (void) {}
void Dfunc (void) {}
void CHzfunc (void) {}
void Chzfunc (void) {}
void afunc (void) {}
void bfunc (void) {}
void czfunc (void) {}
void dfunc (void) {}
void chzfunc (void) {}
int main (void) { return 0;}
EOF

	export LANG=$targetlocale

	cc -c nm_test.c
	nm nm_test.o >out.stdout 2>out.stderr
	grep " T " out.stdout | cut -f 3 -d' ' | diff - nm.expout >/dev/null 2>&1

	result_output_code $? "Can't print symbol names according to the collating sequence."
	rm -rf nm_test.o nm_test.c
}

startup() # startup function
{
	rm -f out.stdout out.tmp out.stderr >/dev/null 2>&1
}


cleanup() # clean-up function
{
	rm -f out.stdout out.tmp out.stderr >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/i18nfuncs.sh
. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
