/*
 * LI18NUX2K.L1/utils/shell/mkfiles.c
 * 
 * Copyright (c) 1991, 1992, 1997, 1998, 1999, 2001 X/Open Company Ltd.
 * (X/Open)
 * trading as The Open Group
 * Copyright (c) 2001, 2003 International Business Machines Corp.
 * All rights reserved except as granted by this License.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the "Artistic License" which comes with this
 * Kit, with the following modification:
 * a) "executable(s)" should be interpreted to include
 * "test case(s)"
 * b) if you wish to make changes as defined in clause 2 and 3, and
 * distribute a modified version of this package, then
 * clauses 3c and 4c are required
 * c) Clause 7 is rephrased as follows: "Subroutines supplied by you
 * and linked into this Package shall not be considered part of this
 * Package".
 *
 *
 * X/OPEN, TRADING AS THE OPEN GROUP, AND IBM CORP. DISCLAIM ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL X/OPEN OR IBM CORP. BE
 * LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * You should have received a copy of the Artistic License with this
 * Kit, in the file named "Artistic".  If not, we'll be glad to provide one.
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define N_FILES 10
#define N_NAME 5
#define N_CHARS 65 /* 26*2 + 10 + 3 */

int main(void)
{
  char *portable_chars = ".-_abcedfghijklmnopqrstuvwxyzABCEDFGHIJKLMNOPQRSTUVWXYZ0123456789";
  int i,j;
  char filename[N_NAME+1];

  srand((unsigned int)time(NULL));
  for(i=0;i<N_FILES;i++)
  {
        /* avoid filename which starts with '.' or '-' */
    filename[0] = portable_chars[(int)(rand()/(RAND_MAX+1.0)*(N_CHARS-2)+2)];
    for(j=1;j<N_NAME;j++)
    {
      filename[j] = portable_chars[(int)(rand()/(RAND_MAX + 1.0) * N_CHARS)];
    }
    filename[j] = '\0';
    printf("%s\n",filename);
  }

  return 0;
}
